# Installs and configures voipmon
class voipmonitor (
  Boolean $manage_cron,
  Boolean $server,
  Boolean $utc,
  String $absolute_timeout,
  String $autocleanmingb,
  String $autocleanspool,
  String $autocleanspoolminpercent,
  String $base_url,
  String $cdr_partition,
  String $cdr_rtpport,
  String $cdr_sipport,
  String $cdrproxy,
  String $cleandatabase,
  Hash $custom_config,
  String $destroy_call_at_bye,
  String $dscp,
  String $filter,
  String $install_location,
  String $managerport,
  String $max_buffer_mem,
  String $maxpoolsize_2,
  String $maxpoolsize,
  String $mos_g729,
  String $mos_lqo_bin,
  String $mos_lqo_ref,
  String $mos_lqo_ref16,
  String $mos_lqo,
  String $nocdr,
  String $ogg_quality,
  String $onewaytimeout,
  String $packetbuffer_compress_ratio,
  String $packetbuffer_compress,
  String $packetbuffer_enable,
  String $pcap_dump_asyncwrite,
  String $pcap_dump_bufflength,
  String $pcap_dump_writethreads_max,
  String $pcap_dump_writethreads,
  String $pcap_dump_zip_rtp,
  String $pcap_dump_zip,
  String $pcap_dump_ziplevel_sip,
  String $promisc,
  String $ringbuffer,
  String $saveaudio_stereo,
  String $savegraph,
  String $savertcp,
  String $savertp,
  String $savesip,
  String $sip_options,
  String $sip_register_active_nologbin,
  String $sip_register_timeout,
  String $sip_register,
  String $sipport,
  String $tar_compress_graph,
  String $tar_compress_rtp,
  String $tar_compress_sip,
  String $tar_graph_level,
  String $tar_maxthreads,
  String $tar_rtp_level,
  String $tar_sip_level,
  String $tar,
  String $timezone,
  String $html_folder,
  Optional[String] $interface        = undef,
  Optional[String] $spooldir         = undef,
  Optional[String] $spooldir_prefix  = undef,
  Optional[String] $server_password  = undef,
  Optional[String] $server_bind      = undef,
  Optional[String] $server_bind_port = undef,
  Optional[String] $sqlcallend       = undef,
  Optional[String] $sqldriver        = undef,
  Optional[String] $mysqlcompress    = undef,
  Optional[String] $mysqldb          = undef,
  Optional[String] $mysqlhost        = undef,
  Optional[String] $mysqlloadconfig  = undef,
  Optional[String] $mysqlpassword    = undef,
  Optional[String] $mysqlport        = undef,
  Optional[String] $mysqlusername    = undef,
){
  if $server {
    if $spooldir == undef {
      fail('spooldir has to be defined when installing server')
    }
    class { 'voipmonitor::sniffer::install':
      base_url         => $base_url,
      install_location => $install_location,
      spooldir_prefix  => $spooldir_prefix,
    }
    voipmonitor::service { 'voipmonitor':
      ensure => running,
      enable => true,
    }
    voipmonitor::config { 'server':
      server                       => true,
      config_filename              => '/etc/voipmonitor.conf',
      service_name                 => 'voipmonitor',
      html_folder                  => $html_folder,
      mysqlcompress                => $mysqlcompress,
      mysqldb                      => $mysqldb,
      mysqlhost                    => $mysqlhost,
      mysqlloadconfig              => $mysqlloadconfig,
      mysqlpassword                => $mysqlpassword,
      mysqlport                    => $mysqlport,
      mysqlusername                => $mysqlusername,
      server_bind                  => $server_bind,
      server_bind_port             => $server_bind_port,
      server_password              => $server_password,
      id_sensor                    => '1',
      interface                    => $interface,
      absolute_timeout             => $absolute_timeout,
      autocleanmingb               => $autocleanmingb,
      autocleanspool               => $autocleanspool,
      autocleanspoolminpercent     => $autocleanspoolminpercent,
      cdr_partition                => $cdr_partition,
      cdr_rtpport                  => $cdr_rtpport,
      cdr_sipport                  => $cdr_sipport,
      cdrproxy                     => $cdrproxy,
      cleandatabase                => $cleandatabase,
      custom_config                => $custom_config,
      destroy_call_at_bye          => $destroy_call_at_bye,
      dscp                         => $dscp,
      filter                       => $filter,
      managerport                  => $managerport,
      managerip                    => '127.0.0.1',
      max_buffer_mem               => $max_buffer_mem,
      maxpoolsize                  => $maxpoolsize,
      maxpoolsize_2                => $maxpoolsize_2,
      mos_g729                     => $mos_g729,
      mos_lqo                      => $mos_lqo,
      mos_lqo_bin                  => $mos_lqo_bin,
      mos_lqo_ref                  => $mos_lqo_ref,
      mos_lqo_ref16                => $mos_lqo_ref16,
      nocdr                        => $nocdr,
      ogg_quality                  => $ogg_quality,
      onewaytimeout                => $onewaytimeout,
      packetbuffer_compress        => $packetbuffer_compress,
      packetbuffer_compress_ratio  => $packetbuffer_compress_ratio,
      packetbuffer_enable          => $packetbuffer_enable,
      pcap_dump_asyncwrite         => $pcap_dump_asyncwrite,
      pcap_dump_bufflength         => $pcap_dump_bufflength,
      pcap_dump_writethreads       => $pcap_dump_writethreads,
      pcap_dump_writethreads_max   => $pcap_dump_writethreads_max,
      pcap_dump_zip                => $pcap_dump_zip,
      pcap_dump_zip_rtp            => $pcap_dump_zip_rtp,
      pcap_dump_ziplevel_sip       => $pcap_dump_ziplevel_sip,
      promisc                      => $promisc,
      ringbuffer                   => $ringbuffer,
      saveaudio_stereo             => $saveaudio_stereo,
      savegraph                    => $savegraph,
      savertcp                     => $savertcp,
      savertp                      => $savertp,
      savesip                      => $savesip,
      sip_options                  => $sip_options,
      sip_register                 => $sip_register,
      sip_register_active_nologbin => $sip_register_active_nologbin,
      sip_register_timeout         => $sip_register_timeout,
      sipport                      => $sipport,
      spooldir                     => $spooldir,
      sqlcallend                   => $sqlcallend,
      sqldriver                    => $sqldriver,
      tar                          => $tar,
      tar_compress_graph           => $tar_compress_graph,
      tar_compress_rtp             => $tar_compress_rtp,
      tar_compress_sip             => $tar_compress_sip,
      tar_graph_level              => $tar_graph_level,
      tar_maxthreads               => $tar_maxthreads,
      tar_rtp_level                => $tar_rtp_level,
      tar_sip_level                => $tar_sip_level,
      timezone                     => $timezone,
      utc                          => $utc,
    }
    class { 'voipmonitor::server::install':
      html_folder      => $html_folder,
      install_location => $install_location,
      manage_cron      => $manage_cron,
      spooldir_prefix  => $spooldir_prefix,
    }
  } else {
    if $spooldir_prefix == undef {
      fail('spooldir_prefix has to be defined when installing sniffer')
    }
    class { 'voipmonitor::sniffer::install':
      base_url         => $base_url,
      install_location => $install_location,
      spooldir_prefix  => $spooldir_prefix,
    }
  }
}
