#Creates a sniffer
define voipmonitor::sniffer (
  String $id_sensor,
  String $interface,
  String $managerport,
  String $managerip,
  String $server_destination,
  String $server_destination_port,
  String $server_password,
  Boolean $enable                      = lookup('voipmonitor::sniffer::enable'),
  Boolean $utc                         = lookup('voipmonitor::utc'),
  String $absolute_timeout             = lookup('voipmonitor::absolute_timeout'),
  String $autocleanmingb               = lookup('voipmonitor::autocleanmingb'),
  String $autocleanspool               = lookup('voipmonitor::autocleanspool'),
  String $autocleanspoolminpercent     = lookup('voipmonitor::autocleanspoolminpercent'),
  String $cdr_rtpport                  = lookup('voipmonitor::cdr_rtpport'),
  String $cdr_sipport                  = lookup('voipmonitor::cdr_sipport'),
  String $cdrproxy                     = lookup('voipmonitor::cdrproxy'),
  Hash $custom_config                  = {},
  String $destroy_call_at_bye          = lookup('voipmonitor::destroy_call_at_bye'),
  String $dscp                         = lookup('voipmonitor::dscp'),
  String $ensure                       = lookup('voipmonitor::sniffer::ensure'),
  String $filter                       = lookup('voipmonitor::filter'),
  String $max_buffer_mem               = lookup('voipmonitor::max_buffer_mem'),
  String $maxpoolsize                  = lookup('voipmonitor::maxpoolsize'),
  String $maxpoolsize_2                = lookup('voipmonitor::maxpoolsize_2'),
  String $mos_g729                     = lookup('voipmonitor::mos_g729'),
  String $mos_lqo                      = lookup('voipmonitor::mos_lqo'),
  String $mos_lqo_bin                  = lookup('voipmonitor::mos_lqo_bin'),
  String $mos_lqo_ref                  = lookup('voipmonitor::mos_lqo_ref'),
  String $mos_lqo_ref16                = lookup('voipmonitor::mos_lqo_ref16'),
  String $nocdr                        = lookup('voipmonitor::nocdr'),
  String $ogg_quality                  = lookup('voipmonitor::ogg_quality'),
  String $onewaytimeout                = lookup('voipmonitor::onewaytimeout'),
  String $packetbuffer_compress        = lookup('voipmonitor::packetbuffer_compress'),
  String $packetbuffer_compress_ratio  = lookup('voipmonitor::packetbuffer_compress_ratio'),
  String $packetbuffer_enable          = lookup('voipmonitor::packetbuffer_enable'),
  String $pcap_dump_asyncwrite         = lookup('voipmonitor::pcap_dump_asyncwrite'),
  String $pcap_dump_bufflength         = lookup('voipmonitor::pcap_dump_bufflength'),
  String $pcap_dump_writethreads       = lookup('voipmonitor::pcap_dump_writethreads'),
  String $pcap_dump_writethreads_max   = lookup('voipmonitor::pcap_dump_writethreads_max'),
  String $pcap_dump_zip                = lookup('voipmonitor::pcap_dump_zip'),
  String $pcap_dump_zip_rtp            = lookup('voipmonitor::pcap_dump_zip_rtp'),
  String $pcap_dump_ziplevel_sip       = lookup('voipmonitor::pcap_dump_ziplevel_sip'),
  String $promisc                      = lookup('voipmonitor::promisc'),
  String $ringbuffer                   = lookup('voipmonitor::ringbuffer'),
  String $saveaudio_stereo             = lookup('voipmonitor::saveaudio_stereo'),
  String $savegraph                    = lookup('voipmonitor::savegraph'),
  String $savertcp                     = lookup('voipmonitor::savertcp'),
  String $savertp                      = lookup('voipmonitor::savertp'),
  String $savesip                      = lookup('voipmonitor::savesip'),
  String $sip_options                  = lookup('voipmonitor::sip_options'),
  String $sip_register                 = lookup('voipmonitor::sip_register'),
  String $sip_register_active_nologbin = lookup('voipmonitor::sip_register_active_nologbin'),
  String $sip_register_timeout         = lookup('voipmonitor::sip_register_timeout'),
  String $sipport                      = lookup('voipmonitor::sipport'),
  String $spooldir_prefix              = lookup('voipmonitor::spooldir_prefix'),
  String $tar                          = lookup('voipmonitor::tar'),
  String $tar_compress_graph           = lookup('voipmonitor::tar_compress_graph'),
  String $tar_compress_rtp             = lookup('voipmonitor::tar_compress_rtp'),
  String $tar_compress_sip             = lookup('voipmonitor::tar_compress_sip'),
  String $tar_graph_level              = lookup('voipmonitor::tar_graph_level'),
  String $tar_maxthreads               = lookup('voipmonitor::tar_maxthreads'),
  String $tar_rtp_level                = lookup('voipmonitor::tar_rtp_level'),
  String $tar_sip_level                = lookup('voipmonitor::tar_sip_level'),
) {
  $spooldir = "${spooldir_prefix}${id_sensor}"
  file { $spooldir:
    ensure => directory
  }
  voipmonitor::config { "voipmonitor-${id_sensor}":
    absolute_timeout             => $absolute_timeout,
    autocleanmingb               => $autocleanmingb,
    autocleanspool               => $autocleanspool,
    autocleanspoolminpercent     => $autocleanspoolminpercent,
    cdr_rtpport                  => $cdr_rtpport,
    cdr_sipport                  => $cdr_sipport,
    cdrproxy                     => $cdrproxy,
    config_filename              => "/etc/voipmonitor-${id_sensor}.conf",
    custom_config                => $custom_config,
    destroy_call_at_bye          => $destroy_call_at_bye,
    dscp                         => $dscp,
    filter                       => $filter,
    id_sensor                    => $id_sensor,
    interface                    => $interface,
    managerport                  => $managerport,
    managerip                    => $managerip,
    max_buffer_mem               => $max_buffer_mem,
    maxpoolsize                  => $maxpoolsize,
    maxpoolsize_2                => $maxpoolsize_2,
    mos_g729                     => $mos_g729,
    mos_lqo                      => $mos_lqo,
    mos_lqo_bin                  => $mos_lqo_bin,
    mos_lqo_ref                  => $mos_lqo_ref,
    mos_lqo_ref16                => $mos_lqo_ref16,
    nocdr                        => $nocdr,
    ogg_quality                  => $ogg_quality,
    onewaytimeout                => $onewaytimeout,
    packetbuffer_compress        => $packetbuffer_compress,
    packetbuffer_compress_ratio  => $packetbuffer_compress_ratio,
    packetbuffer_enable          => $packetbuffer_enable,
    pcap_dump_asyncwrite         => $pcap_dump_asyncwrite,
    pcap_dump_bufflength         => $pcap_dump_bufflength,
    pcap_dump_writethreads       => $pcap_dump_writethreads,
    pcap_dump_writethreads_max   => $pcap_dump_writethreads_max,
    pcap_dump_zip                => $pcap_dump_zip,
    pcap_dump_zip_rtp            => $pcap_dump_zip_rtp,
    pcap_dump_ziplevel_sip       => $pcap_dump_ziplevel_sip,
    promisc                      => $promisc,
    ringbuffer                   => $ringbuffer,
    saveaudio_stereo             => $saveaudio_stereo,
    savegraph                    => $savegraph,
    savertcp                     => $savertcp,
    savertp                      => $savertp,
    savesip                      => $savesip,
    server_destination           => $server_destination,
    server_destination_port      => $server_destination_port,
    server_password              => $server_password,
    service_name                 => "voipmonitor-${id_sensor}",
    sip_options                  => $sip_options,
    sip_register                 => $sip_register,
    sip_register_active_nologbin => $sip_register_active_nologbin,
    sip_register_timeout         => $sip_register_timeout,
    sipport                      => $sipport,
    spooldir                     => $spooldir,
    tar                          => $tar,
    tar_compress_graph           => $tar_compress_graph,
    tar_compress_rtp             => $tar_compress_rtp,
    tar_compress_sip             => $tar_compress_sip,
    tar_graph_level              => $tar_graph_level,
    tar_maxthreads               => $tar_maxthreads,
    tar_rtp_level                => $tar_rtp_level,
    tar_sip_level                => $tar_sip_level,
    utc                          => $utc,
  }
  voipmonitor::service { "voipmonitor-${id_sensor}":
    ensure => $ensure,
    enable => $enable
  }
}
